import { jsxs as t, jsx as e } from "react/jsx-runtime";

import { useLayoutEffect as o, useEffect as r, useState as n, useMemo as i, useCallback as s, useRef as l } from "react";

import { VirtualScrollerEvent as c, VirtualScroller as a } from "@af-utils/virtual-core";

import { useSyncExternalStore as h } from "use-sync-external-store/shim/index.js";

const d = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to; n > r; r++) o.push(e(r));
    return o;
}, f = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to, i = t.getOffset(r); n > r; i += t.getSize(r), r++) o.push(e(r, i));
    return o;
}, u = "undefined" != typeof window ? o : r, m = {
    position: "relative",
    overflow: "hidden",
    contain: "strict",
    zIndex: -1
}, p = {
    ...m,
    height: "100%"
}, y = {
    ...m,
    width: "100%"
}, S = {
    position: "absolute",
    contain: "strict",
    overflow: "hidden",
    top: 0,
    left: 0
}, g = {
    ...S,
    display: "flex",
    height: "100%"
}, w = {
    ...S,
    display: "block",
    width: "100%"
}, x = t => {
    const [e, o] = n(null), [r, i] = n(null);
    return u((() => {
        if (t && e && r) {
            const o = () => {
                e.style[t.horizontal ? "width" : "height"] = t.scrollSize + "px";
            }, n = () => {
                const e = t.getOffset(t.from), o = t.getOffset(t.to);
                r.style.transform = `translate${t.horizontal ? "X" : "Y"}(${e}px)`, r.style[t.horizontal ? "width" : "height"] = o - e + "px";
            }, i = t.on(o, [ c.SCROLL_SIZE ]), s = t.on(n, [ c.RANGE, c.SIZES ]);
            return Object.assign(e.style, t.horizontal ? p : y), Object.assign(r.style, t.horizontal ? g : w), 
            o(), n(), () => {
                i(), s();
            };
        }
    }), [ t, e, r ]), [ o, i ];
};

function v(t) {
    switch (t) {
      case c.RANGE:
        return this.to ** 2 + this.from;

      case c.SCROLL_SIZE:
        return this.scrollSize;

      default:
        return this.sizesHash;
    }
}

const z = (t, e) => {
    const [o, r] = i((() => [ o => t.on(o, e), () => e.map(v, t).join() ]), [ t, e ]);
    h(o, r, r);
}, O = t => (z(t.model, t.events), t.children()), b = o => {
    const {model: r, children: n, itemData: i, component: l = "div", header: a = null, footer: h = null, getKey: f = (t => t), tabIndex: u = -1, style: m, ...p} = o, [y, S] = x(r);
    return t(l, {
        ...p,
        style: {
            overflow: "auto",
            contain: "strict",
            ...m
        },
        ref: s((t => r.setScroller(t)), [ r ]),
        tabIndex: u,
        children: [ a, e("div", {
            ref: y,
            children: e("div", {
                ref: S,
                children: e(O, {
                    model: r,
                    events: [ c.RANGE ],
                    children: () => d(r, (t => e(n, {
                        model: r,
                        i: t,
                        data: i
                    }, f(t, i))))
                })
            })
        }), h ]
    });
}, E = (t, e) => u((() => (t.setScroller(e), () => t.setScroller(null))), [ t, e ]), I = (t, e, o) => r((() => {
    if (o) return o(), t.on(o, e);
}), [ t, o, e ]), j = t => l().current ||= new a(t), R = t => {
    const e = j(t);
    return u((() => e.set(t))), e;
};

export { b as List, O as Subscription, d as mapVisibleRange, f as mapVisibleRangeWithOffset, z as useComponentSubscription, E as useScroller, I as useSubscription, x as useSyncedStyles, R as useVirtual, j as useVirtualModel };
//# sourceMappingURL=index.js.map
